//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.MetadataConsumerTest
{
    
    
    /// <summary>
    /// A class that exposes the IMetadataConsumerTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class MetadataConsumerTestProvider : IFeatureProvider
    {
        
        private IMetadataConsumerTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(MetadataConsumerTestProvider).Assembly, "MetadataConsumerTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public MetadataConsumerTestProvider(IMetadataConsumerTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EchoStringMetadataRequestDto, EchoStringMetadataResponseDto>("EchoStringMetadata", EchoStringMetadata);
            registration.RegisterUnobservableCommand<UnpackMetadataRequestDto, UnpackMetadataResponseDto>("UnpackMetadata", UnpackMetadata);
            registration.RegisterUnobservableProperty("ReceivedStringMetadata", GetReceivedStringMetadata);
            registration.RegisterObservableProperty("ReceivedStringMetadataAsCharacters", GetReceivedStringMetadataAsCharacters, _implementation);
        }
        
        /// <summary>
        /// Executes the Echo String Metadata command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoStringMetadataResponseDto EchoStringMetadata(EchoStringMetadataRequestDto request)
        {
            request.Validate();
            return new EchoStringMetadataResponseDto(_implementation.EchoStringMetadata(), _server);
        }
        
        /// <summary>
        /// Executes the Echo String And Structure Metadata command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual UnpackMetadataResponseDto UnpackMetadata(UnpackMetadataRequestDto request)
        {
            request.Validate();
            return new UnpackMetadataResponseDto(_implementation.UnpackMetadata(), _server);
        }
        
        /// <summary>
        /// Gets the current value of the Received String Metadata property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetReceivedStringMetadata()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.ReceivedStringMetadata, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Received String Metadata As Characters property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual ReceivedStringMetadataAsCharactersResponseDto GetReceivedStringMetadataAsCharacters()
        {
            return new ReceivedStringMetadataAsCharactersResponseDto(_implementation.ReceivedStringMetadataAsCharacters, _server);
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/MetadataConsumerTest/v1/Command/EchoStringMetadata"))
            {
                return typeof(IMetadataConsumerTest).GetMethod("EchoStringMetadata");
            }
            if ((commandIdentifier == "org.silastandard/test/MetadataConsumerTest/v1/Command/UnpackMetadata"))
            {
                return typeof(IMetadataConsumerTest).GetMethod("UnpackMetadata");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadata"))
            {
                return typeof(IMetadataConsumerTest).GetProperty("ReceivedStringMetadata");
            }
            if ((propertyIdentifier == "org.silastandard/test/MetadataConsumerTest/v1/Property/ReceivedStringMetadataAsCh" +
                "aracters"))
            {
                return typeof(IMetadataConsumerTest).GetProperty("ReceivedStringMetadataAsCharacters");
            }
            return null;
        }
    }
}

